## DBM ##
###
#######################################################
#		Home Free v3.24n (Nearly Null)
#     
#    		Created by Solution Scripts
# 		Email: solutions@solutionscripts.com
#		Web: http://solutionscripts.com
#
#######################################################
#
#
# COPYRIGHT NOTICE:
#
# Copyright 1999 Solution Scripts  All Rights Reserved.
#
# Selling the code for this program without prior written consent is
# expressly forbidden. In all cases
# copyright and header must remain intact.
#
#######################################################

package Account;

use Fcntl;
use AnyDBM_File;
use Config;

$dbtype="dbm";
$dbpck = 'AnyDBM_File';
$flags = O_CREAT | O_RDWR;

########## SIGNUP STUFF #########
sub cate_increment {
	
my $inc_cata = $_[0];
my $up_down = $_[1];

$db = "$main::path/cata";
tie(%cata, $dbpck, $db , $flags, 0666) || &main::error("Cannot open database-- $db");
if ($cata{$inc_cata}) {
	@cata = split(/\|/,$cata{$inc_cata});
	$caat=$cata[0];
	if ($up_down) {
	  	$cata[8]++;
	}
	else {
	  	$cata[8] = $cata[8] - 1;
	}
  	$cata{$inc_cata} = join("\|",@cata);
}	
untie(%cata);
	  
$dir_acc = "$caat/$dir_acc";

}

########## GET CATEGORY HASH ##########
sub get_cata_hash {

undef %ccata;

$db = "$main::path/cata";
tie(%bata, $dbpck, $db , $flags, 0666) || &main::error("Cannot open database-- $db");
while ( ($key, $value) = each(%bata) ) {
	$ccata{$key} = $value;
}
untie(%bata);

return(%ccata);
}

########## PRINT CATEGORY ##########
sub print_cata_hash {

$db = "$main::path/cata";
tie(%bata, $dbpck, $db , $flags, 0666) || &main::error("Cannot open database-- $db");
while ( ($key, $value) = each(%bata) ) {
	delete $bcata{$key};
}

while ( ($key, $value) = each(%cata) ) {
	$bata{$key} = $value;
}

untie(%bata);
}


########## CREATE NEW CATA ##########
sub new_cata_creation {

my $new_cata = $_[0];
my $new_data = $_[1];

$db = "$main::path/cata";
tie(%cata, $dbpck, $db , $flags, 0666) || &main::error("Cannot open database-- $db");
$cata{$new_cata} = $new_data;
untie(%cata);

}

########## CREATE NEW CATA ##########
sub delete_cata {

my $new_cata = $_[0];

$db = "$main::path/cata";
tie(%cata, $dbpck, $db , $flags, 0666) || &main::error("Cannot open database-- $db");
delete $cata{$new_cata};
untie(%cata);

}


########## GET ACCOUNT DATA ##########
sub get_account { 



$db = "$main::path/$cata";
tie(%cata, $dbpck, $db , $flags, 0666) || &main::error("Cannot open database-- $db");
unless ($cata{$account}) {
	untie(%cata);
	return(0); 
}

my $acc_data = $cata{$account};
untie(%cata);

($email,$name,$pwd,$size,$creation,$last_log,$size_added,$hf_on,
	$website_name,$website_des,$numdirs,$www_of,$www_name,$www_bgcolor,
	$www_bgimage,$www_text,$www_link,$www_vlink,$onhold,$address,$city,
	$state,$zip,$country,$telephone,$gender,$age,$icq,$education,
	$income,$occupation,$d_o_b,$moderator,$gbook_of,$op_in,$icon_url,
	$file_types,$ftp_per,$session_str,$num_dirs,$num_files,
	$custom_1,$custom_2,$custom_3,$custom_4,$custom_5,$custom_6,$custom_7,
	$custom_8,$custom_9,$custom_10,$marital,$signup_ip,$last_ip,$formmail_of) = split(/\|/,$acc_data);

($month,$day,$year1,$year2) = split (/\,/,$d_o_b);

@tfile = split(/\,/,$file_types);

foreach (@tfile) {
	if ($_ eq "\.shtml") {
		$main::good_types{$_} = "html";
	}
	else {		
		$main::good_types{$_} = "file";
	}
}

return(1);
}

########## PRINT ACCOUNT DATA BACK ######################
sub print_account {

$acc_data =("$email|$name|$pwd|$size|$creation|$last_log|$size_added|$hf_on|$website_name|$website_des|$numdirs|$www_of|$www_name|$www_bgcolor|$www_bgimage|$www_text|$www_link|$www_vlink|$onhold|$address|$city|$state|$zip|$country|$telephone|$gender|$age|$icq|$education|$income|$occupation|$d_o_b|$moderator|$gbook_of|$op_in|$icon_url|$file_types|$ftp_per|$session_str|$num_dirs|$num_files|$custom_1|$custom_2|$custom_3|$custom_4|$custom_5|$custom_6|$custom_7|$custom_8|$custom_9|$custom_10|$marital|$signup_ip|$last_ip|$formmail_of");

$db = "$main::path/$cata";
tie(%cata, $dbpck, $db , $flags, 0666) || &main::error("Cannot open database-- $db");
$cata{$account} = $acc_data;
untie(%cata);

}

######### DELETE ACCOUNT ##########
sub delete_account {

$db = "$main::path/$cata";
tie(%cata, $dbpck, $db , $flags, 0666) || &main::error("Cannot open database-- $db");
delete $cata{$account};
untie(%cata);
}

########## GET HASH OF ACCOUNTS IN CATEGORY ##########
sub get_acc_hash {

undef %dcata;
my $cata = $_[0];

$db = "$main::path/$cata";
tie(%bata, $dbpck, $db , $flags, 0666) || &main::error("Cannot open database-- $db");
while ( ($key, $value) = each(%bata) ) {
      $dcata{$key} = $value;
}
untie(%bata);

return(%dcata);
}

######### SORT HASHES ##########
sub sort_hash {
	my $x = shift;
	my %array=%$x;
	sort { $array{$a} cmp $array{$b} } keys %array;
}

1;


